import sys
import re

# multiplica una matriz 4,4 por un vector 4,1
def multiply(m, v):
	vf = [0, 0, 0, 0]
	for x in range(4):
		for y in range(4):
			vf[x] = vf[x] + m[x][y]*v[y]
	return vf


try:
	fd = open("intervals")
	l = fd.read().split('\n')
	fd.close()
except IOError:
	print "Error: Cannot open intervals file."
	sys.exit()

i=0			# Por si no esta al principio del fichero
while not re.match("GLOBAL TRANSFORMATION",l[i]):
	i = i + 1

# leemos la matriz global
matrix = ( l[i+3].split(' '), l[i+4].split(' '), l[i+5].split(' '), l[i+6].split(' ') )

# la convertimos a floats
for x in range(4):
	for y in range(4):
		matrix[x][y] = float(matrix[x][y])

# leemos las matrices de los segmentos y las guardamos en un hash
# llamado segmentMatrix, con el numero de aminoacido como key 
segmentMatrix = {}
for i in range(len(l)):
	if re.match("SEGMENT",l[i]):
		m = ( l[i+3].split(' '), l[i+4].split(' '), l[i+5].split(' '), l[i+6].split(' ') )
		for x in range(4):
			for y in range(4):
				m[x][y] = float(m[x][y])
		amino = l[i+1].split(' ')
		for j in range(int(amino[0]),int(amino[1])+1):
			segmentMatrix[j] = m

try:
	fd = open("1ar1B1.pdb")
	l = fd.read().split('\n')
	fd.close()
except IOError:
	print "Error: Cannot open 1ar1B1.pdb!"
	sys.exit()

try:
	new = open("new.pdb",'w')
except:
	print "Error: Cannot create the new file."
	sys.exit()

# aplicamos la matriz global y la de cada segmento, y 
# construimos el fichero resultante
for linia in l:
	if re.match("ATOM",linia) or re.match("HETATM",linia):
		coord = linia[32:59].split('  ')
		for i in range(4):
			coord[i] = float(coord[i])

		amino = int(linia[23:26])	#leemos el numero de aminoacido

		vfinal = multiply(matrix, coord)
		if (segmentMatrix.has_key(amino)):
			vfinal = multiply(segmentMatrix[amino], vfinal)

		new.write(linia[0:30])
		for i in range(3):
			res = "%.3f" % vfinal[i]
			if len(res) == 5:
				new.write("   " + res)
			elif len(res) == 6:
				new.write("  " + res)
			else:
				new.write(" " + res)
	
		new.write("  1.00" + linia[60:] + '\n')	
	else:
		new.write(linia + '\n')

new.close()
