import sys
import re

# multiplica una matriz 4,4 por un vector 4,1
def multiply(m, v):
	vf = [0, 0, 0, 0]
	for x in range(4):
		for y in range(4):
			vf[x] = vf[x] + m[x][y]*v[y]
	return vf

if len(sys.argv) != 2:
	print "The script needs a pdb file as argument."
	sys.exit() 

try:
	fd = open("intervals")
	l = fd.read().split('\n')
	fd.close()
except IOError:
	print "Error: Cannot open intervals file."
	sys.exit()

i=0			# Por si no esta al principio del fichero
while not re.match("GLOBAL TRANSFORMATION",l[i]):
	i = i + 1

# leemos la matriz global
matrix = ( l[i+3].split(' '), l[i+4].split(' '), l[i+5].split(' '), l[i+6].split(' ') )

# la convertimos a floats
for x in range(4):
	for y in range(4):
		matrix[x][y] = float(matrix[x][y])

# leemos las matrices de los segmentos y las guardamos en un hash
# llamado segmentMatrix, con el numero de aminoacido como key 
segmentMatrix = {}
for i in range(len(l)):
	if re.match("SEGMENT",l[i]):
		m = ( l[i+3].split(' '), l[i+4].split(' '), l[i+5].split(' '), l[i+6].split(' ') )
		for x in range(4):
			for y in range(4):
				m[x][y] = float(m[x][y])
		amino = l[i+1].split(' ')
		for j in range(int(amino[0]),int(amino[1])+1):
			segmentMatrix[j] = m

try:
	fd = open(sys.argv[1])
	l = fd.read().split('\n')
	fd.close()
except IOError:
	print "Error: Cannot open " + sys.argv[1] + "."
	sys.exit()

try:
	rigid = open("prot2rigid.pdb",'w')
	deform = open("prot2deform.pdb",'w')
except:
	print "Error: Cannot create the output files."
	sys.exit()

# aplicamos la matriz global y la de cada segmento, y 
# construimos los ficheros resultantes
for linia in l:
	if re.match("ATOM",linia) or re.match("HETATM",linia):
		coord = [float(linia[30:37]),float(linia[38:45]),float(linia[46:53]),1.0]
		amino = int(linia[23:26])	#leemos el numero de aminoacido

		coord_global = multiply(matrix, coord)
		if (segmentMatrix.has_key(amino)):
			vfinal = multiply(segmentMatrix[amino], coord_global)

		rigid.write(linia[0:30])
		deform.write(linia[0:30])

		for i in range(3):
			res = "%.3f" % coord_global[i]
                        if(segmentMatrix.has_key(amino)):
                                coord = "%.3f" % vfinal[i]
                        else:
                                coord = "%.3f" % coord_global[i]

			if len(res) == 5:
				rigid.write("   " + res)
			elif len(res) == 6:
				rigid.write("  " + res)
			else:
				rigid.write(" " + res)

			if len(coord) == 5:
				deform.write("   " + coord)
			elif len(coord) == 6:
				deform.write("  " + coord)
			else:
				deform.write(" " + coord)

	
		rigid.write("  1.00" + linia[60:] + '\n')
		deform.write("  1.00" + linia[60:] + '\n')	
	else:
		rigid.write(linia + '\n')
		deform.write(linia + '\n')

rigid.close()
deform.close()
