from pymol import cmd
import sys
import re

# look for the manual at:
# http://pymol.sourceforge.net/newman/user/S0220commands.html

cmd.load("prot2deform.pdb")
cmd.hide("all")
cmd.show("cartoon")

try:
	fd = open("intervals")
	lines = fd.read().split('\n')
	fd.close()
except IOError:
	print "Cannot open intervals file."
	sys.exit()

try:
	fd = open("prot2deform.pdb")
	pdb = fd.read().split('\n')
	fd.close()
except IOError:
	print "Cannot open pdb2deform.pdb"
	sys.exit();

#keep the atom numbers of each CA
alpha = {}
for i in range(len(pdb)):
	if re.match("ATOM",pdb[i]) and pdb[i][13:15] == "CA":
		alpha[int(pdb[i][22:26])] = int(pdb[i][6:11])
	elif re.match("HETATM",pdb[i]) and pdb[i][12:14] == "CA":
		alpha[int(pdb[i][22:26])] = int(pdb[i][6:11])

num_dotted = 1

for i in range(len(lines)): 
	if re.match("SEGMENT",lines[i]): 
		if re.match("-1 -1",lines[i+2]):	# a subchain that is not matched		
			values = lines[i+1].split(' ')
			cmd.color("black", "resi " + values[0] + ":" + values[1])  
		elif re.match("-2 -2",lines[i+2]):      # a subchain that is not matched and not shown
			values = lines[i+1].split(' ')
			cmd.hide("(resi " + values[0] + ":" + values[1] + ")")
	elif re.match("DOTTED LINE",lines[i]):		
		values = lines[i+1].split(' ')        # a dotted line between residues that where adjacent
		values[0] = int(values[0])
		values[1] = int(values[1])
		
		if(alpha.has_key(values[0]) and alpha.has_key(values[1])):
			cmd.distance("_dist"+str(num_dotted),"id " + str(alpha[values[0]]), "id " + str(alpha[values[1]]))
			num_dotted = num_dotted+1
		else:
			print "Cannot find CA of the aminoacids " + str(values[0]) + " or " + str(values[1])

cmd.hide("labels")
cmd.color("green","_dist*")


