/*

<BetaTopo.c>

coded by Takeshi Kawabata.

*/


#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "protein.h"


void Set_Beta_Topology();
void Set_Coil_Type();



void Set_Beta_Topology(pr)
 struct PROTEIN *pr;
{
 int i,j,db1,dn1,db2,dn2,d;
 char T1,T2,T;
 int buldge,Nsta,Nend,bps,bpe;


 for (i=1;i<=pr->Naa;++i) 
 { 
 if (pr->Sec[i]=='E') 
 {
   db1 = dn1 = db2 = dn2 = 0;
   T1 = T2 = ' '; 
   if (pr->BP1[i]>0)
   {   
    if (pr->BP1[i-1]>0) db1 = pr->BP1[i]   - pr->BP1[i-1];
    if (pr->BP1[i+1]>0) dn1 = pr->BP1[i+1] - pr->BP1[i];
    if ((db1 ==  1)||(dn1 ==  1)) T1 = 'p';
    if ((db1 == -1)||(dn1 == -1)) T1 = 'a';
    }
 
   if (pr->BP2[i]>0)
   {   
    if (pr->BP2[i-1]>0) db2 = pr->BP2[i]   - pr->BP2[i-1];
    if (pr->BP2[i+1]>0) dn2 = pr->BP2[i+1] - pr->BP2[i];
    if ((db2 ==  1)||(dn2 ==  1)) T2 = 'p';
    if ((db2 == -1)||(dn2 == -1)) T2 = 'a';
    }

        if ((T1=='p')&&(T2=='a')) pr->Top[i] = 'M';
   else if ((T1=='a')&&(T2=='p')) pr->Top[i] = 'M';
   else if ((T1=='p')||(T2=='p')) pr->Top[i] = 'P';
   else if ((T1=='a')||(T2=='a')) pr->Top[i] = 'A';
   else pr->Top[i] = '*';
   } else pr->Top[i] = pr->Sec[i];
  /*
  printf("%3d %c %c %3d %3d %c %c %c\n",i,pr->Seq[i],pr->Sec[i],
   pr->BP1[i],pr->BP2[i],T1,T2,pr->Top[i]); 
  */
  }


  /*** CHANGE BULDGE "*" to "P" or "A" ***/ 
  buldge = 0;
  
  for (i=1;i<= pr->Naa; ++i)
  {
     if ((pr->Top[i] == '*')&&(buldge==0)) { buldge = 1; Nsta = i;}

     if ((pr->Top[i] != '*')&&(buldge== 1))
     { 
      buldge = 0; Nend = i-1;
      T = '?';   

           if (pr->BP1[Nsta] != 0)   bps = pr->BP1[Nsta]; 
      else if (pr->BP1[Nsta-1] != 0) bps = pr->BP1[Nsta-1]; 
      else                           bps = 0;

           if (pr->BP1[Nend]   != 0) bpe = pr->BP1[Nend]; 
      else if (pr->BP1[Nend+1] != 0) bpe = pr->BP1[Nend+1]; 
      else                           bpe = 0;

      if ((bps != 0)&&(bpe != 0)) 
       { d = bpe - bps; if (d>0) T = 'P'; else T = 'A'; }
     
           if (pr->BP2[Nsta] != 0)   bps = pr->BP2[Nsta]; 
      else if (pr->BP2[Nsta-1] != 0) bps = pr->BP2[Nsta-1]; 
      else                           bps = 0;

           if (pr->BP2[Nend]   != 0) bpe = pr->BP2[Nend]; 
      else if (pr->BP2[Nend+1] != 0) bpe = pr->BP2[Nend+1]; 
      else                           bpe = 0;

      if ((bps != 0)&&(bpe != 0)) 
       { d = bpe - bps; if (d>0) T = 'P'; else T = 'A'; }
     
      for (j=Nsta;j<=Nend;++j) pr->Top[j] = T;  
      
       }
   }



} /* end of Set_Beta_Topology() */



void Set_Coil_Type(pr)
 struct PROTEIN *pr;
{
 int i;

 for (i=1;i<=pr->Naa;++i)
  if ((pr->Sec[i] != 'H')&&(pr->Sec[i] != 'E'))
   { 
         if ((pr->Phi[i]<=0.0)&&(pr->Psi[i]<=60.0)&&(pr->Psi[i]>=-120.0)) pr->Top[i] = 'g';

    else if ((pr->Phi[i]>0.0)&&(pr->Psi[i]<=120.0)&&(pr->Psi[i]>=-120.0)) pr->Top[i] = 'l';

    else  pr->Top[i] = 'b';
    } 

} /* end of Set_Coil_Type() */

