/*

<DiheDis.c>

coded by Takeshi Kawabata.

*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Vector.h" 
#include "main.h" 
#include "protein.h" 

float Bond_Angle();
float Dihedral_Angle();
void Cal_PhiPsi();


float Bond_Angle(A,B,C)
 float A[3],B[3],C[3];
{ float BA[3],BC[3],bon;

  /* A\ /C
       B   */

  Sub_Vec(3,BA,A,B); Normalize(3,BA);
  Sub_Vec(3,BC,C,B); Normalize(3,BC);
  bon = acos(BA[0]*BC[0] + BA[1]*BC[1] + BA[2]*BC[2]) * 180.0 /M_PI;
  return(bon);

} /* end of Bond_Angle() */




float Dihedral_Angle(A,B,C,D)
 float A[3],B[3],C[3],D[3];
{
 float CB[3],CD[3],BC[3],BA[3],a[3],b[3],s[3];
 float prod1,prod2,Dih;

 /*  A\   /D
       B-C    */

 Sub_Vec(3,CB,B,C);
 Sub_Vec(3,CD,D,C);
 Sub_Vec(3,BA,A,B);
 Sub_Vec(3,BC,C,B);
 Cross_Vec(a,BA,BC); Normalize(3,a);
 Cross_Vec(b,CB,CD); Normalize(3,b);
 Cross_Vec(s,a,b);
 prod1 = a[0]*b[0]+a[1]*b[1]+a[2]*b[2];
 prod2 = CB[0]*s[0] + CB[1]*s[1] + CB[2]*s[2];
 if (prod1> 1.0) prod1 =  1.0; if (prod1<-1.0) prod1 = -1.0; 
 Dih = acos(prod1) * 180.0 /M_PI;
 if (prod2>0.0) Dih = -Dih + 360.0 ;
 if (Dih>=180.0) Dih -= 360.0; 
 return(Dih);

} /* end of Dihedral_Angle() */




void Cal_PhiPsi(pr)
 struct PROTEIN *pr;
{ int i;

 pr->Phi[1] =  pr->Omega[1] = pr->Psi[pr->Naa] = 360.0;

 for (i=1;i<= pr->Naa ;++i)
  {
   if (i>=2)
    { pr->Phi[i]   = Dihedral_Angle(pr->PosC[i-1],pr->PosN[i],pr->PosCA[i],pr->PosC[i]);
      if ( pr->Phi[i] >180.0) pr->Phi[i] -= 360;

      pr->Omega[i] = Dihedral_Angle(pr->PosCA[i-1],pr->PosC[i-1],pr->PosN[i],pr->PosCA[i]);
      if ( pr->Omega[i] < 0.0) pr->Omega[i] += 360.0;

       if (pr->Omega[i]<30.0)  printf("CIS %3d %c omega %.2lf\n",i,pr->Seq[i],pr->Omega[i]);

      }
    if (i< pr->Naa)
     { pr->Psi[i]   = Dihedral_Angle(pr->PosN[i],pr->PosCA[i],pr->PosC[i],pr->PosN[i+1]);
       if (pr->Psi[i]>180.0) pr->Psi[i] -= 360; }

  }

} /* end of Cal_PhiPsi() */















