/*

 <LlistAlign.h>

*/


/*** STRUCTURE FOR ALIGNMENT ***/ 

/* This if for both res-res alignments and SSE-SSE alignments.

  *Range of array is different. 
   for res-res- alignments
     nalA[],nalB[] : 1...Nali
   for sse-sse- alignments
     nalA[],nalB[] : 0...Nali-1
*/

struct AlignNode{
  int  num;     /* Node Number */
  int  Nali;    /* Number of residues in alignment */  
  int  *nalA;   /* (malloc later) */     
  int  *nalB;   /* (malloc later) */    
  float *scores; /* (malloc later) JR Indvidual pair scores */
  int  MaxNali; /* Aligned Number for *nalA and *nalB */
  struct AlignNode *prev;  /* Pointer for Previous Node */
  struct AlignNode *next;  /* Pointer for Next Node     */ 

  /** Range Information**/
  int  staA,endA; /* start and end residue for protein A */ 
  int  staB,endB; /* start and end residue for protein B */ 
 
  /*** Value ***/ 
  float value;     /* this is for MergeSort      */
  float subvalue;  /* this is for linear fitting */
  float Zsc;       /* Zscore */
  char mark;       /* Mark for various purposes  */ 


  /** Pointer to SIMILARITY **/
  char   mal_sim;          /* if mal_sim == 1, sim is malloced. */
  struct SIMILARITY *sim;  /* (malloc later) */
  
  /** Pointer to SSE_Alignment **/
  struct AlignNode *sn;    /* of cource, it is for res-res alignment */
 
  /** Pointer to PROTEIN **/
  char   mal_pro;          /* if mal_pro == 1,  pro is malloced.   */
  struct PROTEIN *pro;     /* (malloc later) <- for ONE-VS-LIBRARY */
};



/*** STRUCTURE FOR SIMILARITY ***/ 

struct SIMILARITY{
  char *Name;      /* malloc later */ 
  char *Tax;       /* malloc later */
  char mal_nametax; /* if '1', Name[] and Tax[] are alreadly malloced. */
  int Naa,Nsse; 
  int Ncomp,Ncomp_sse; 
  float SeqID,SecID,ExpID; 
  float ScEnv,ScDis,ScSSE,ScAA,Rdis,Rsse; 
  float CRMS,DRMS;
  float RelO,RelS;
  char mark;
};



/**** FUNCTIONS *****/

extern void Malloc_AlignNode();
extern void Show_AlignNode();
extern void Add_AlignNode_To_Tail();
extern void Free_AlignNode_Llist();
extern void Free_AlignNode();
extern struct AlignNode *Tail_AlignNode();
extern float Tail_Value_AlignNode();
extern int Number_Of_Nodes();
extern void Joint_AlignList();
extern void Set_Sta_End_Of_Alignment();
extern void Equal_AlignNode();
extern void Free_AlignNode_Llist_Thre_Value();

