/**

<ScoreENV.c>

coded by Takeshi Kawabata.

**/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include "main.h"
#include "protein.h"
#include "ScoreENV.h"
#include "Amino.h"
#include "GotohDPdis.h"
#include "ScoreSSE.h"
#include "LlistAlign.h"


/*********************************/
/*** SUBSTITUTION SCORE MATRIX ***/
/*********************************/

static int D250[21][21] = {
{ +2, -1, -2, -1, -4, +1, +0, -2, +0, +0, -1, +0, -2, +0, -1, +1, +1, -6, -3, +1, 0},
{ -1, +5, +2, +2, +1, -2, +4, -2, -2, -2, -2, -2, -2, -2, -2, -1, +0, -5, -1, -3, 0},
{ -2, +2, +6, +4, +2, -3, +2, -3, -4, -3, -3, -3, -6, -2, -2, -3, -2, -2, -1, -4, 0},
{ -1, +2, +4, +6, +0, -2, +2, +0, -3, -2, +0, -2, -5, -1, -2, -2, -1, -4, -2, -3, 0},
{ -4, +1, +2, +0, +9, -5, -1, -4, -6, -5, -5, -4, -4, -5, -2, -3, -3, +0, +7, -5, 0},
{ +1, -2, -3, -2, -5, +6, -1, +0, -1, -1, -1, -1, -3, +0, +0, +1, +0, -6, -5, -1, 0},
{ +0, +4, +2, +2, -1, -1, +4, -2, -2, -2, -2, -2, -2, -2, -2, -1, +0, -6, -2, -1, 0},
{ -2, -2, -3, +0, -4, +0, -2, +6, -1, -1, +3, +0, -4, +1, +2, +0, -1, +2, -4, -3, 0},
{ +0, -2, -4, -3, -6, -1, -2, -1, +4, +3, +0, +2, -5, +2, +1, +0, +0, -7, -4, +1, 0},
{ +0, -2, -3, -2, -5, -1, -2, -1, +3, +4, +0, +1, -5, +2, +1, +0, +0, -7, -4, +0, 0},
{ -1, -2, -3, +0, -5, -1, -2, +3, +0, +0, +5, +1, -5, +1, +0, +0, +0, -3, -4, -2, 0},
{ +0, -2, -3, -2, -4, -1, -2, +0, +2, +1, +1, +2, -4, +1, +2, +1, +0, -4, -2, +0, 0},
{ -2, -2, -6, -5, -4, -3, -2, -4, -5, -5, -5, -4,+12, -5, -3, +0, -2, -8, +0, -3, 0},
{ +0, -2, -2, -1, -5, +0, -2, +1, +2, +2, +1, +1, -5, +4, +3, -1, -1, -5, -4, -1, 0},
{ -1, -2, -2, -2, -2, +0, -2, +2, +1, +1, +0, +2, -3, +3, +6, -1, -1, -3, +0, -2, 0},
{ +1, -1, -3, -2, -3, +1, -1, +0, +0, +0, +0, +1, +0, -1, -1, +2, +1, -2, -3, +1, 0},
{ +1, +0, -2, -1, -3, +0, +0, -1, +0, +0, +0, +0, -2, -1, -1, +1, +3, -5, -3, +0, 0},
{ -6, -5, -2, -4, +0, -6, -6, +2, -7, -7, -3, -4, -8, -5, -3, -2, -5,+17, +0, -7, 0},
{ -3, -1, -1, -2, +7, -5, -2, -4, -4, -4, -4, -2, +0, -4, +0, -3, -3, +0,+10, -5, 0},
{ +1, -3, -4, -3, -5, -1, -1, -3, +1, +0, -2, +0, -3, -1, -2, +1, +0, -7, -5, +5, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, } };

static int BL62[21][21] = {
{ +4, -1, -1, -1, -2, -1, +0, -1, -2, -1, -1, -2, +0, -1, -2, +1, +0, -3, -2, +0, +0},
{ -1, +4, +2, +1, +0, -3, +3, -3, -3, -3, -3, -3, -1, -3, -3, -2, -1, -3, -1, -4, -1},
{ -1, +2, +4, +2, +0, -3, +1, -2, -4, -3, -2, -3, -1, -2, -3, -2, -1, -2, -1, -4, -1},
{ -1, +1, +2, +5, +0, -2, +1, -1, -3, -2, -1, -2, -1, +0, -2, -1, -1, -1, -1, -3, -1},
{ -2, +0, +0, +0, +6, -4, -1, -3, -3, -3, -3, -3, -2, -3, -1, -2, -2, +1, +3, -3, -1},
{ -1, -3, -3, -2, -4, +7, -2, -2, -1, -1, -1, -2, -3, -1, -2, -1, -1, -4, -3, -2, -2},
{ +0, +3, +1, +1, -1, -2, +4, -3, -3, -2, -2, -3, -1, -2, -3, -2, +0, -3, -1, -3, -1},
{ -1, -3, -2, -1, -3, -2, -3, +5, -2, +0, +2, +0, -3, +1, +0, -1, -1, -3, -2, -2, -1},
{ -2, -3, -4, -3, -3, -1, -3, -2, +6, +2, -1, +1, -3, +0, -1, +0, -1, -4, -3, -1, -1},
{ -1, -3, -3, -2, -3, -1, -2, +0, +2, +5, +1, +0, -4, +2, +0, +0, -1, -3, -2, -2, -1},
{ -1, -3, -2, -1, -3, -1, -2, +2, -1, +1, +5, +0, -3, +1, -1, +0, -1, -3, -2, -2, -1},
{ -2, -3, -3, -2, -3, -2, -3, +0, +1, +0, +0, +6, -3, +0, +1, +1, +0, -4, -2, +0, -1},
{ +0, -1, -1, -1, -2, -3, -1, -3, -3, -4, -3, -3, +9, -3, -3, -1, -1, -2, -2, -3, -2},
{ -1, -3, -2, +0, -3, -1, -2, +1, +0, +2, +1, +0, -3, +5, +0, +0, -1, -2, -1, -2, -1},
{ -2, -3, -3, -2, -1, -2, -3, +0, -1, +0, -1, +1, -3, +0, +8, -1, -2, -2, +2, -2, -1},
{ +1, -2, -2, -1, -2, -1, -2, -1, +0, +0, +0, +1, -1, +0, -1, +4, +1, -3, -2, +0, +0},
{ +0, -1, -1, -1, -2, -1, +0, -1, -1, -1, -1, +0, -1, -1, -2, +1, +5, -2, -2, -2, +0},
{ -3, -3, -2, -1, +1, -4, -3, -3, -4, -3, -3, -4, -2, -2, -2, -3, -2,+11, +2, -2, -2},
{ -2, -1, -1, -1, +3, -3, -1, -2, -3, -2, -2, -2, -2, -1, +2, -2, -2, +2, +7, -3, -1},
{ +0, -4, -4, -3, -3, -2, -3, -2, -1, -2, -2, +0, -3, -2, -2, +0, -2, -2, -3, +6, -1},
{ +0, -1, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -2, -1, -1, +0, +0, -2, -1, -1, -1}};


static int BL50[21][21] = {
{ +5, -1, -2, -1, -3, -1, +0, -2, -2, -1, -1, -1, -1, -1, -2, +1, +0, -3, -2, +0, -1},
{ -1, +5, +2, +2, +0, -3, +4, -4, -4, -4, -3, -3, -2, -3, -4, -3, -1, -3, -1, -4, -1},
{ -2, +2, +5, +3, +1, -4, +1, -3, -4, -3, -3, -4, -2, -2, -3, -3, -1, -2, -1, -4, -1},
{ -1, +2, +3, +7, +0, -3, +1, -2, -4, -2, -2, -2, -2, +0, -1, -2, -1, -1, +0, -3, -1},
{ -3, +0, +1, +0, +8, -4, -1, -3, -5, -3, -4, -4, -2, -4, -1, -3, -2, +1, +4, -4, -2},
{ -1, -3, -4, -3, -4,+10, -3, -3, -1, -1, -1, -2, -4, -1, -2, -1, -1, -4, -3, -2, -2},
{ +0, +4, +1, +1, -1, -3, +5, -3, -4, -3, -3, -3, -1, -3, -4, -2, +0, -3, -1, -4, -1},
{ -2, -4, -3, -2, -3, -3, -3, +7, -2, +0, +3, -1, -4, +1, +0, -1, -1, -3, -1, -3, -1},
{ -2, -4, -4, -4, -5, -1, -4, -2, +8, +2, -1, +2, -4, +0, -1, +0, -1, -5, -3, -1, -1},
{ -1, -4, -3, -2, -3, -1, -3, +0, +2, +6, +1, +0, -3, +2, +0, -1, -1, -3, -2, -3, -1},
{ -1, -3, -3, -2, -4, -1, -3, +3, -1, +1, +6, +0, -3, +2, +0, +0, -1, -3, -2, -2, -1},
{ -1, -3, -4, -2, -4, -2, -3, -1, +2, +0, +0, +7, -2, +0, +1, +1, +0, -4, -2, +0, -1},
{ -1, -2, -2, -2, -2, -4, -1, -4, -4, -3, -3, -2,+13, -3, -3, -1, -1, -5, -3, -3, -2},
{ -1, -3, -2, +0, -4, -1, -3, +1, +0, +2, +2, +0, -3, +7, +1, +0, -1, -1, -1, -2, -1},
{ -2, -4, -3, -1, -1, -2, -4, +0, -1, +0, +0, +1, -3, +1,+10, -1, -2, -3, +2, -2, -1},
{ +1, -3, -3, -2, -3, -1, -2, -1, +0, -1, +0, +1, -1, +0, -1, +5, +2, -4, -2, +0, -1},
{ +0, -1, -1, -1, -2, -1, +0, -1, -1, -1, -1, +0, -1, -1, -2, +2, +5, -3, -2, -2, +0},
{ -3, -3, -2, -1, +1, -4, -3, -3, -5, -3, -3, -4, -5, -1, -3, -4, -3,+15, +2, -3, -3},
{ -2, -1, -1, +0, +4, -3, -1, -1, -3, -2, -2, -2, -3, -1, +2, -2, -2, +2, +8, -3, -1},
{ +0, -4, -4, -3, -4, -2, -4, -3, -1, -3, -2, +0, -3, -2, -2, +0, -2, -3, -3, +8, -2},
{ -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -1, -1, -2, -1, -1, -1, +0, -3, -1, -2, -1}};


static int J220[21][21] = {
{ +3, +0, -2, -1, -3, +1, +1, -1, -1, -1, -2, +0, -1, -1, -2, +1, +2, -4, -4, +1, +0},
{ +0, +5, +2, +3, +0, -2, +4, -3, -4, -4, -3, -2, -3, -3, -3, -1, +1, -4, -3, -3, -1},
{ -2, +2, +5, +3, +2, -1, +2, -3, -5, -5, -4, -3, -3, -2, -2, -2, -1, -2, -1, -4, -1},
{ -1, +3, +3, +6, +0, -2, +3, -2, -4, -4, -2, -3, -3, -2, -3, -2, +0, -3, -3, -4, -1},
{ -3, +0, +2, +0, +9, -3, -1, -5, -5, -6, -6, -4, +0, -4, -1, -2, -3, -1, +5, -5, -2},
{ +1, -2, -1, -2, -3, +7, -2, -1, -3, -3, -2, -1, -2, +0, +0, +1, +0, -5, -4, -2, -1},
{ +1, +4, +2, +3, -1, -2, +4, -3, -3, -3, -3, -2, -2, -3, -3, -1, +0, -4, -3, -2, -1},
{ -1, -3, -3, -2, -5, -1, -3, +5, -2, -1, +4, +0, -1, +2, +2, -1, -1, +0, -3, +0, -1},
{ -1, -4, -5, -4, -5, -3, -3, -2, +6, +4, +0, +2, -4, +0, +0, -1, -1, -6, -3, +1, -1},
{ -1, -4, -5, -4, -6, -3, -3, -1, +4, +5, +1, +1, -4, +2, -1, -1, -2, -5, -4, +0, -1},
{ -2, -4, -4, -2, -6, -2, -3, +4, +0, +1, +6, +1, -3, +2, +0, -1, -1, -3, -4, -1, -1},
{ +0, -2, -3, -2, -4, -1, -2, +0, +2, +1, +1, +4, -1, +0, +1, +1, +1, -5, -1, +0, +0},
{ -1, -3, -3, -3, +0, -2, -2, -1, -4, -4, -3, -1,+12, -3, -1, +1, -1, +1, +2, -1, -1},
{ -1, -3, -2, -2, -4, +0, -3, +2, +0, +2, +2, +0, -3, +6, +3, -1, -1, -4, -2, -2, -1},
{ -2, -3, -2, -3, -1, +0, -3, +2, +0, -1, +1, +1, -1, +3, +7, -1, -1, -3, +4, -2, -1},
{ +1, -1, -2, -2, -2, +1, -1, -1, -1, -1, -1, +1, +1, -1, -1, +2, +2, -3, -2, +1, +0},
{ +2, +1, -1, +0, -3, +0, +0, -1, -1, -2, -1, +1, -1, -1, -1, +2, +3, -4, -3, -1, +0},
{ -5, -4, -2, -4, -1, -5, -4, +0, -6, -6, -4, -5, +1, -4, -4, -3, -4,+15, -1, -2, -3},
{ -4, -3, -1, -3, +5, -4, -3, -3, -3, -4, -4, -1, +2, -2, +4, -2, -3, -1,+10, -4, -2},
{ +1, -3, -4, -3, -5, -2, -2, +0, +1, +0, -1, +0, -1, -2, -2, +1, -1, -2, -5, +6, -1},
{ +0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, +0, -1, -1, -1, +0, +0, -3, -2, -1, -1} };

static int IDEN[21][21] = {
{  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, 0},
{  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 1}};


static float EnvROM[30][30];  /* Environmental Related Odds Matrix */


/******** FUNCTIONS (GLOBAL) ********/

void Read_EnvROM();
void Read_Env_Score();
int Number_Hyb();
float ResMatchScore();

/******** FUNCTIONS (LOCAL) ********/
static int Number_Sec();
static int  Number_TopExp();
static char TopExp_Number();





float ResMatchScore(pA,i,pB,j,sn,Offtype)
 /*
   Environmental residue-residude matching score 
   between "i-th residue on pA" and "j-th residue on pB" 
 */
 struct PROTEIN *pA,*pB;
 int i,j;
 struct AlignNode *sn; /** SSE Alignment **/
 char Offtype;  /* 'O':use offset of sse alignment */
{ int s,t,a,b;
  float sc,ninf;

  ninf = -1000000000.0; 
  /*** Add Offset value for SSE alignment ***/  

  if (Offtype=='O') sc = SseOffsetSc(pA,i,pB,j,sn,'E'); 
            else    sc = 0.0;

  /** 
    Constraint ConAtoB[]
  **/
  
  if ((PAR.ConOffset > 0) && (PAR.ConAtoB[i]>0) && (PAR.ConAtoB[i] == j)) 
   sc += PAR.ConOffset;  
  
  if ((PAR.SelfAvoidType=='T') && (i==j)) return(ninf);  

  /*( If Alimap[i][j] == 1 (masked), return large penalty. ***/
  if (PAR.mal_alimap == 1)  if (PAR.Alimap[i][j]==1) return(ninf); 

 
  if (PAR.EnvScType=='T')
    {  s = Number_TopExp(pA->Top[i],pA->Exp[i],PAR.Nenvstate);
       t = Number_TopExp(pB->Top[j],pB->Exp[j],PAR.Nenvstate);
       sc += EnvROM[s][t]; }

 else if (PAR.EnvScType=='D')  
   sc += (float)D250[numAA[pA->Seq[i]]][numAA[pB->Seq[j]]];

 else if (PAR.EnvScType=='B')  
   sc += (float)BL62[numAA[pA->Seq[i]]][numAA[pB->Seq[j]]];
 
 else if (PAR.EnvScType=='J')  
   sc += (float)J220[numAA[pA->Seq[i]]][numAA[pB->Seq[j]]];

 else if (PAR.EnvScType=='A')
    sc += EnvROM[numAA[pA->Seq[i]]][numAA[pB->Seq[j]]]; 
 
 else if ((PAR.EnvScType=='S')&&(PAR.Nenvstate==3))
  { s = Number_Sec(pA->Sec[i],3);
    t = Number_Sec(pB->Sec[j],3);
    sc += EnvROM[s][t]; }

 else if ((PAR.EnvScType=='S')&&(PAR.Nenvstate==8))
  { s = Number_Sec(pA->Sec[i],8);
    t = Number_Sec(pB->Sec[j],8);
    sc += EnvROM[s][t]; }

 else if ((PAR.EnvScType=='H')&&(PAR.Nenvstate==6))
  { 
    s = Number_Hyb(pA->Sec[i],pA->Exp[i]);
    t = Number_Hyb(pB->Sec[j],pB->Exp[j]);
    sc += EnvROM[s][t]; }

 return(sc);

} /* end of ResMatchScore() */





void Read_Env_Score(fname)
 char *fname;
{
 FILE *fp;
 int s,t,L;
 char buffer[128]; 
 char Fname[128],buff1[64],buff2[64];
 char rom_on;
 float val;

 /*
 <FORMAT EXAMPLE>
 CLASS ENVIRONMENT
 @TYPE T
 @NSTATE 10
 @NMULTI 3
 @SIGMA  10000.000000
 @STATE_OF_NAME
 0 H
 1 E
 2 G
 : 
 @RELATED_ODDS_MATRIX
 0 0 14.653613
 0 1 -27.222739
 0 2 -0.054136
 : 
 */

 sprintf(Fname,"%s/%s",SCORE_DIR,fname);
 
 fp = fopen(Fname,"r");
 if (fp==NULL) { printf("#ERROR:Can't find envscorefile \"%s\"\n",Fname); exit(1);}
 rom_on = 0;
 
 while (feof(fp)==0)
 {
  buffer[0] = '\0';
  fgets(buffer,128,fp);
  L = strlen(buffer);
  if (buffer[L-1]=='\n') buffer[L-1]= '\0';
  if ((buffer[0]!='#')&&(L>1))
  {
   if (buffer[0]=='@') rom_on = 0;
   if (strncmp(buffer,"@NSTATE",7)==0) 
    { sscanf(buffer,"%s %d",buff1,&(PAR.Nenvstate)); 
      /** INITIALIZE **/
      for (s=0;s<PAR.Nenvstate;++s)
       for (t=s;t<PAR.Nenvstate;++t) EnvROM[s][t] = EnvROM[t][s] = 0.0; 
      }


   if (strncmp(buffer,"@TYPE",5)==0)   
    { sscanf(buffer,"%s %s",buff1,buff2); PAR.EnvScType = buff2[0];}

   if (rom_on==1)
   { sscanf(buffer,"%d %d %f",&s,&t,&val);
     EnvROM[s][t] = EnvROM[t][s] = val;
     /* printf("%d %d %lf\n",s,t,EnvROM[s][t]);  */
    }
     
    if (strncmp(buffer,"@RELATED_ODDS_MATRIX",20)==0) rom_on = 1;
   } 

  } /* while */

 fclose(fp);

} /* end of Read_EnvROM() */









int Number_Sec(sym,Nstr)
 int Nstr;
{
 if (Nstr == 3)
 switch(sym)
  {
    case 'H': return(0); break;
    case 'E': return(1); break;
    default : return(2); break;
   }

 else if (Nstr == 4)
 switch(sym)
  {
    case 'H': return(0); break;
    case 'E': return(1); break;
    case 'T': return(2); break;
    default : return(3); break;
   }

 else if (Nstr == 8)
 switch(sym)
  {
    case 'H': return(0); break;
    case 'B': return(1); break;
    case 'E': return(2); break;
    case 'G': return(3); break;
    case 'I': return(4); break;
    case 'T': return(5); break;
    case 'S': return(6); break;
    default : return(7); break;
  }
}

int Number_Hyb(sec,exp)
 char sec;
 char exp;
{
  if (exp=='b')
      {      if (sec=='H') return(0);
        else if (sec=='E') return(1);
        else               return(2);  }
  else
      {      if (sec=='H') return(3);
        else if (sec=='E') return(4);
        else               return(5);  }
}



int Number_TopExp(top,exp,Nstr)
 char top,exp;
 int Nstr;
{
 if (Nstr==10)
 {
  if (exp=='b')
  switch(top)
   { case 'H': return(0); break;
     case 'P': return(1); break;
     case 'A': return(1); break;
     case 'M': return(1); break;
     case 'E': return(1); break;
     case 'G': return(2); break;
     case 'g': return(2); break;
     case 'B': return(3); break;
     case 'b': return(3); break;
     case 'l': return(4); break;
     default : return(4); break; }
  else
  switch(top)
  { case 'H': return(5); break;
    case 'P': return(6); break;
    case 'A': return(6); break;
    case 'M': return(6); break;
    case 'E': return(6); break;
    case 'G': return(7); break;
    case 'g': return(8); break;
    case 'B': return(8); break;
    case 'b': return(8); break;
    case 'l': return(9); break;
    default : return(9); break; }
  }

 if (Nstr==14)
 {
  if (exp=='b')
  switch(top)
   { case 'H': return(0); break;
     case 'P': return(1); break;
     case 'A': return(2); break;
     case 'M': return(3); break;
     case 'G': return(4); break;
     case 'B': return(5); break;
     default : return(6); break; }
  else
  switch(top)
  { case 'H': return(7); break;
    case 'P': return(8); break;
    case 'A': return(9); break;
    case 'M': return(10); break;
    case 'G': return(11); break;
    case 'B': return(12); break;
    default : return(13); break; }
  }



 if (Nstr==5)
  switch(top)
   { case 'H': return(0); break;
     case 'P': return(1); break;
     case 'A': return(2); break;
     case 'M': return(3); break;
     default : return(4); break; }

}

char TopExp_Number(n)
 int n;
{
 switch(n)
  {
    case  0 : return('H'); break;
    case  1 : return('P'); break;
    case  2 : return('A'); break;
    case  3 : return('M'); break;
    case  4 : return('C'); break;
    case  5 : return('h'); break;
    case  6 : return('p'); break;
    case  7 : return('a'); break;
    case  8 : return('m'); break;
    default : return('c'); break;
   }
}




