/*

<Vector.c>

*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void Equal_Vec();
void Sub_Vec();
void Add_Vec();
float Dot_Prod();
void Cross_Vec();
void Scalar_Prod();
int Normalize();
float Distance();
void Print_Vec();

void Print_Vec(n,A)
 int n;
 float *A;
{ int i;
  for (i=0;i<n;++i) printf(" %lf",A[i]); printf("\n"); }



void Equal_Vec(n,A,B)
 int n;
 float *A,*B;
{ int i;
  for (i=0;i<n;++i) A[i] = B[i]; }



void Sub_Vec(n,C,A,B)
 int n;
 float *C,*A,*B;
{ int i;
  for (i=0;i<n;++i) C[i] = A[i] - B[i]; }


void Add_Vec(n,C,A,B)
 int n;
 float *C,*A,*B;
{ int i;
  for (i=0;i<n;++i) C[i] = A[i] + B[i]; }


float Dot_Prod(n,A,B)
 int n;
 float *A,*B;
{ int i;
  float prod;
  prod = 0.0;
  for (i=0;i<n;++i) prod += A[i]*B[i];
  return(prod); }


void Cross_Vec(C,A,B)   /* This function is only for 3-D */
 float C[3],A[3],B[3];
{ C[0] = A[1]*B[2] - A[2]*B[1];
  C[1] = A[2]*B[0] - A[0]*B[2];
  C[2] = A[0]*B[1] - A[1]*B[0]; }



void Scalar_Prod(n,C,scalar,A)
 int n;
 float *C,scalar,*A;
{ int i;
  for (i=0;i<n;++i) C[i] = scalar * A[i]; }


int Normalize(n,A)
 int n;
 float *A;
{ int i;
  float len;
  len = sqrt(Dot_Prod(n,A,A));
  if (len>0.0) { for (i=0;i<n;++i) A[i] /= len; return(1);}
          else { printf("Normalize Error (Zero Length)\n"); return(0); }
}


float Distance(n,A,B)
 int n;
 float *A,*B;
{ int i;
  float len,S[3];
  Sub_Vec(3,S,A,B);
  len = sqrt(Dot_Prod(n,S,S));
  return(len);
}







