// way to use the stl class with clapack

template<class Type> class cl_complex {
public:
	Type r,i;

	cl_complex(Type u,Type v);
	cl_complex(cl_complex<Type>& u);
	cl_complex(Type u=0);
	

	cl_complex<Type>& operator=(cl_complex<Type>&);
	cl_complex<Type>& operator=(Type);
	cl_complex<Type>& operator+=(cl_complex<Type>&);
	/*
	template<class Type> friend cl_complex<Type>	operator+(cl_complex<Type>&,cl_complex<Type>&);
	template<class Type> friend cl_complex<Type>	operator*(cl_complex<Type>&,cl_complex<Type>&);
	template<class Type> friend cl_complex<Type>	operator*(Type,cl_complex<Type>&);
	template<class Type> friend cl_complex<Type>	operator-(cl_complex<Type>&,cl_complex<Type>&);
	template<class Type> friend cl_complex<Type>	operator-(cl_complex<Type>&);
	template<class Type> friend cl_complex<Type>	operator/(cl_complex<Type>&,cl_complex<Type>&);
	template<class Type> friend cl_complex<Type>	operator/(cl_complex<Type>&,Type);
	template<class Type> friend cl_complex<Type> conj(cl_complex<Type>&);
	*/

};


template<class Type> cl_complex<Type>	operator+(cl_complex<Type>&,cl_complex<Type>&);
template<class Type> cl_complex<Type>	operator*(cl_complex<Type>&,cl_complex<Type>&);
template<class Type> cl_complex<Type>	operator*(Type,cl_complex<Type>&);
template<class Type> cl_complex<Type>	operator-(cl_complex<Type>&,cl_complex<Type>&);
template<class Type> cl_complex<Type>	operator-(cl_complex<Type>&);
template<class Type> cl_complex<Type>	operator/(cl_complex<Type>&,cl_complex<Type>&);
template<class Type> cl_complex<Type>	operator/(cl_complex<Type>&,Type);
template<class Type> cl_complex<Type> conj(cl_complex<Type>&);


template<class Type> cl_complex<Type>::cl_complex(Type u)
{
	r=u;
	i=0;
}

template<class Type> cl_complex<Type>::cl_complex(Type u,Type v)
{
	r=u;
	i=v;
}

template<class Type> cl_complex<Type>::cl_complex(cl_complex<Type>& u)
{
	r=u.r;
	i=u.i;
}


/////////////////////////  Maths operators  //////////////////////////////////

template<class Type> cl_complex<Type>& cl_complex<Type>::operator=(cl_complex<Type>& u)
{
	r=u.r;
	i=u.i;
	return *this;
}

template<class Type> cl_complex<Type>& cl_complex<Type>::operator+=(cl_complex<Type>& u)
{
	r+=u.r;
	i+=u.i;
	return *this;
}


template<class Type> cl_complex<Type>& cl_complex<Type>::operator=(Type v)
{
	r=v;
	i=0;
	return *this;
}

template<class Type> cl_complex<Type> operator+(cl_complex<Type>& u,cl_complex<Type>& v)
{
	cl_complex<Type> w(u.r+v.r,u.i+v.i);
	return w;
}



template<class Type> cl_complex<Type> operator-(cl_complex<Type>& u,cl_complex<Type>& v)
{
	cl_complex<Type> w(u.r-v.r,u.i-v.i);
	return w;
}

template<class Type> cl_complex<Type> operator-(cl_complex<Type>& u)
{
	cl_complex<Type> w(-u.r,-u.i);
	return w;
}

template<class Type> cl_complex<Type> operator*(cl_complex<Type>& u,cl_complex<Type>& v)
{
	cl_complex<Type> w;

	w.r=u.r*v.r-u.i*v.i;
	w.i=u.r*v.i+u.i*v.r;

	return w;
}

template<class Type> cl_complex<Type> operator*(Type u,cl_complex<Type>& v)
{
	cl_complex<Type> w(u*v.r,u*v.i);
	return w;
}

template<class Type> cl_complex<Type> operator/(cl_complex<Type>& v,Type u)
{
	cl_complex<Type> w(v.r/u,v.i/u);
	return w;
}

template<class Type> cl_complex<Type> operator/(cl_complex<Type>& u,cl_complex<Type>& v)
{
	cl_complex<Type> w;

	Type f=1/(v.r*v.r+v.i*v.i);
	w=f*u*conj(v);
	return w;
}

template<class Type> cl_complex<Type> conj(cl_complex<Type>& u)
{
	cl_complex<Type> w(u.r,-u.i);
	return w;
}

template<class Type> Type magsq(cl_complex<Type>& u)
{
	return u.r*u.r+u.i*u.i;
}


/////////////////////////  Input/Output  ///////////////////////////////////////


template<class Type> ostream& operator<<(ostream &s, cl_complex<Type>& u)
{

	s<<"("<<u.r<<","<<u.i<<")";
    return s;
}


template<class Type> istream& operator>>(istream &s, cl_complex<Type>& u)
{
	char c;
	s>>c>>u.r>>c>>u.i>>c;
    return s;
}
