// #include <windows.h>
#include <list>
#include <math.h>
#include "matrix_clapack.h"
#include "vector.h"

Matrix<double> matrix_rep_axis(Vector<double> w )
{
  // Copy in wc the matrix representation of the cross product with w   

Matrix<double> wc(3,3);
  wc = 0;

  wc(0,1) = -w(2);

  wc(0,2) =  w(1);

  wc(1,0) =  w(2);

  wc(1,2) = -w(0);

  wc(2,0) = -w(1);

  wc(2,1) =  w(0);

return wc;

}

double cosangle(Vector<double> v, Vector<double> w)
{
double normv,normw, normvw;
normv=(Transpose(v)*v)(0);
normw=(Transpose(w)*w)(0);
normvw=(Transpose(v)*w)(0);
if (normv > 0 && normw > 0) {
  return normvw/sqrt(normv*normw);
}

return 1; 
}

Vector<double> cross_product(Vector<double> v, Vector<double> w)
{
return matrix_rep_axis(v)*w;
}

double norm_vect(Vector<double> vect) {

  int i;
  Vector<double> sumV(1);

  sumV= Transpose(vect)*vect;
  
  
  return(sumV(0));

}


Vector<double> normalize_vect(Vector<double> vect) {

  int i;
  Vector<double> sumV(1);
  double factor;
  sumV= Transpose(vect)*vect;
  
  if (sumV(0) != 0){
        factor= 1 /sqrt(sumV(0));
        return factor*vect;
  }

  return(vect);

}


Matrix<double>rodrigues_formula(Vector<double> axis, double costheta)  // Given the axis of rotation chi and the amount of rotation theta, 

//				     the rotation matrix is found.   

{

  //  R= Id3x3 + sin*chi + (1-cos)*(chi*chi);   

  Matrix <double> res(3,3);
  Matrix <double> chi(3,3);

  double sint;

  int i;
  res=0;
  for (i=0; i<3; i++)
     res(i,i)=1;

  // res = I

  sint=sqrt(1.0 - costheta*costheta);
  chi=matrix_rep_axis(axis);

  return res + sint*chi + (1-costheta)*(chi*chi);

}



